from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def get_token_penalty_multi_scores_v2(pre_ids,logits,penalty_scores,frequency_scores,presence_scores,temperatures,bad_tokens,cur_len,min_len,eos_token_id):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("get_token_penalty_multi_scores_v2", pre_ids,logits,penalty_scores,frequency_scores,presence_scores,temperatures,bad_tokens,cur_len,min_len,eos_token_id)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'pre_ids' : pre_ids,'logits' : logits,'penalty_scores' : penalty_scores,'frequency_scores' : frequency_scores,'presence_scores' : presence_scores,'temperatures' : temperatures,'bad_tokens' : bad_tokens,'cur_len' : cur_len,'min_len' : min_len,'eos_token_id' : eos_token_id}
        outs = {}
        outs_list = ['logits_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("get_token_penalty_multi_scores_v2", **locals())

        outs['logits_out'] = logits
        helper.append_op(type="get_token_penalty_multi_scores_v2", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def transpose_remove_padding(input,seq_lens,padding_offset):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("transpose_remove_padding", input,seq_lens,padding_offset)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'input' : input,'seq_lens' : seq_lens,'padding_offset' : padding_offset}
        outs = {}
        outs_list = ['fmha_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("transpose_remove_padding", **locals())

        outs['fmha_out'] = helper.create_variable(dtype='float32')
        helper.append_op(type="transpose_remove_padding", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def get_padding_offset_v2(input_ids,cum_offsets,token_num,seq_len,draft_tokens,seq_lens_encoder):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("get_padding_offset_v2", input_ids,cum_offsets,token_num,seq_len,draft_tokens,seq_lens_encoder)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'input_ids' : input_ids,'cum_offsets' : cum_offsets,'token_num' : token_num,'seq_len' : seq_len,'draft_tokens@OPTIONAL' : draft_tokens,'seq_lens_encoder@OPTIONAL' : seq_lens_encoder}
        outs = {}
        outs_list = ['x_remove_padding','cum_offsets_out','padding_offset','cu_seqlens_q','cu_seqlens_k']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("get_padding_offset_v2", **locals())

        outs['x_remove_padding'] = helper.create_variable(dtype='float32')
        outs['cum_offsets_out'] = helper.create_variable(dtype='float32')
        outs['padding_offset'] = helper.create_variable(dtype='float32')
        outs['cu_seqlens_q'] = helper.create_variable(dtype='float32')
        outs['cu_seqlens_k'] = helper.create_variable(dtype='float32')
        helper.append_op(type="get_padding_offset_v2", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def get_position_ids_and_mask_encoder_batch(seq_lens_encoder,seq_lens_decoder,seq_lens_this_time,position_ids,mask_encoder_batch):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("get_position_ids_and_mask_encoder_batch", seq_lens_encoder,seq_lens_decoder,seq_lens_this_time,position_ids,mask_encoder_batch)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'seq_lens_encoder' : seq_lens_encoder,'seq_lens_decoder' : seq_lens_decoder,'seq_lens_this_time' : seq_lens_this_time,'position_ids' : position_ids,'mask_encoder_batch' : mask_encoder_batch}
        outs = {}
        outs_list = ['position_ids_out','mask_encoder_batch_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("get_position_ids_and_mask_encoder_batch", **locals())

        outs['position_ids_out'] = position_ids
        outs['mask_encoder_batch_out'] = mask_encoder_batch
        helper.append_op(type="get_position_ids_and_mask_encoder_batch", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def save_output(x,not_need_stop,msg_queue_id,rank_id):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("save_output", x,not_need_stop,msg_queue_id,rank_id)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'x' : x,'not_need_stop' : not_need_stop,'msg_queue_id' : msg_queue_id}
        outs = {}
        outs_list = ['x_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("save_output", **locals())

        outs['x_out'] = x
        helper.append_op(type="save_output", inputs=ins, outputs=outs, attrs={'rank_id' : rank_id})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def rebuild_padding(tmp_out,padding_offset,seq_lens,input_ids):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("rebuild_padding", tmp_out,padding_offset,seq_lens,input_ids)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'tmp_out' : tmp_out,'padding_offset' : padding_offset,'seq_lens' : seq_lens,'input_ids' : input_ids}
        outs = {}
        outs_list = ['out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("rebuild_padding", **locals())

        outs['out'] = helper.create_variable(dtype='float32')
        helper.append_op(type="rebuild_padding", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def fused_rotary_position_encoding(query,key,position_ids,cos_sin_cache,head_size,is_neox):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("fused_rotary_position_encoding", query,key,position_ids,cos_sin_cache,head_size,is_neox)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'query' : query,'key' : key,'position_ids' : position_ids,'cos_sin_cache' : cos_sin_cache}
        outs = {}
        outs_list = ['query_out','key_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("fused_rotary_position_encoding", **locals())

        outs['query_out'] = query
        outs['key_out'] = key
        helper.append_op(type="fused_rotary_position_encoding", inputs=ins, outputs=outs, attrs={'head_size' : head_size,'is_neox' : is_neox})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def draft_model_update(inter_next_tokens,draft_tokens,pre_ids,seq_lens_this_time,seq_lens_encoder,seq_lens_decoder,step_idx,output_cum_offsets,stop_flags,not_need_stop,max_dec_len,end_ids,base_model_draft_tokens,max_seq_len,substep):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("draft_model_update", inter_next_tokens,draft_tokens,pre_ids,seq_lens_this_time,seq_lens_encoder,seq_lens_decoder,step_idx,output_cum_offsets,stop_flags,not_need_stop,max_dec_len,end_ids,base_model_draft_tokens,max_seq_len,substep)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'inter_next_tokens' : inter_next_tokens,'draft_tokens' : draft_tokens,'pre_ids' : pre_ids,'seq_lens_this_time' : seq_lens_this_time,'seq_lens_encoder' : seq_lens_encoder,'seq_lens_decoder' : seq_lens_decoder,'step_idx' : step_idx,'output_cum_offsets' : output_cum_offsets,'stop_flags' : stop_flags,'not_need_stop' : not_need_stop,'max_dec_len' : max_dec_len,'end_ids' : end_ids,'base_model_draft_tokens' : base_model_draft_tokens}
        outs = {}
        outs_list = ['draft_tokens_out','pre_ids_out','seq_lens_this_time_out','seq_lens_encoder_out','seq_lens_decoder_out','step_idx_out','stop_flags_out','not_need_stop_out','base_model_draft_tokens_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("draft_model_update", **locals())

        outs['draft_tokens_out'] = draft_tokens
        outs['pre_ids_out'] = pre_ids
        outs['seq_lens_this_time_out'] = seq_lens_this_time
        outs['seq_lens_encoder_out'] = seq_lens_encoder
        outs['seq_lens_decoder_out'] = seq_lens_decoder
        outs['step_idx_out'] = step_idx
        outs['stop_flags_out'] = stop_flags
        outs['not_need_stop_out'] = not_need_stop
        outs['base_model_draft_tokens_out'] = base_model_draft_tokens
        helper.append_op(type="draft_model_update", inputs=ins, outputs=outs, attrs={'max_seq_len' : max_seq_len,'substep' : substep})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def qkv_transpose_split(qkv,padding_offset,seq_lens,input_ids,num_head,head_size):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("qkv_transpose_split", qkv,padding_offset,seq_lens,input_ids,num_head,head_size)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'qkv' : qkv,'padding_offset' : padding_offset,'seq_lens' : seq_lens,'input_ids' : input_ids}
        outs = {}
        outs_list = ['q_out','k_out','v_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("qkv_transpose_split", **locals())

        outs['q_out'] = helper.create_variable(dtype='float32')
        outs['k_out'] = helper.create_variable(dtype='float32')
        outs['v_out'] = helper.create_variable(dtype='float32')
        helper.append_op(type="qkv_transpose_split", inputs=ins, outputs=outs, attrs={'num_head' : num_head,'head_size' : head_size})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def set_value_by_flags_and_idx_v2(pre_ids_all,input_ids,seq_lens_this_time,seq_lens_encoder,seq_lens_decoder,step_idx,stop_flags):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("set_value_by_flags_and_idx_v2", pre_ids_all,input_ids,seq_lens_this_time,seq_lens_encoder,seq_lens_decoder,step_idx,stop_flags)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'pre_ids_all' : pre_ids_all,'input_ids' : input_ids,'seq_lens_this_time' : seq_lens_this_time,'seq_lens_encoder' : seq_lens_encoder,'seq_lens_decoder' : seq_lens_decoder,'step_idx' : step_idx,'stop_flags' : stop_flags}
        outs = {}
        outs_list = ['pre_ids_all_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("set_value_by_flags_and_idx_v2", **locals())

        outs['pre_ids_all_out'] = pre_ids_all
        helper.append_op(type="set_value_by_flags_and_idx_v2", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def speculate_get_output_padding_offset(output_cum_offsets_tmp,out_token_num,seq_lens_output,max_seq_len):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("speculate_get_output_padding_offset", output_cum_offsets_tmp,out_token_num,seq_lens_output,max_seq_len)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'output_cum_offsets_tmp' : output_cum_offsets_tmp,'out_token_num' : out_token_num,'seq_lens_output' : seq_lens_output}
        outs = {}
        outs_list = ['output_padding_offset','output_cum_offsets']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("speculate_get_output_padding_offset", **locals())

        outs['output_padding_offset'] = helper.create_variable(dtype='float32')
        outs['output_cum_offsets'] = helper.create_variable(dtype='float32')
        helper.append_op(type="speculate_get_output_padding_offset", inputs=ins, outputs=outs, attrs={'max_seq_len' : max_seq_len})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def set_value_by_flags_and_idx(pre_ids_all,pre_ids_now,step_idx,stop_flags):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("set_value_by_flags_and_idx", pre_ids_all,pre_ids_now,step_idx,stop_flags)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'pre_ids_all' : pre_ids_all,'pre_ids_now' : pre_ids_now,'step_idx' : step_idx,'stop_flags' : stop_flags}
        outs = {}
        outs_list = ['stop_flags_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("set_value_by_flags_and_idx", **locals())

        outs['stop_flags_out'] = helper.create_variable(dtype='float32')
        helper.append_op(type="set_value_by_flags_and_idx", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def speculate_get_seq_lens_output(seq_lens_this_time,seq_lens_encoder,seq_lens_decoder):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("speculate_get_seq_lens_output", seq_lens_this_time,seq_lens_encoder,seq_lens_decoder)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'seq_lens_this_time' : seq_lens_this_time,'seq_lens_encoder' : seq_lens_encoder,'seq_lens_decoder' : seq_lens_decoder}
        outs = {}
        outs_list = ['seq_lens_output']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("speculate_get_seq_lens_output", **locals())

        outs['seq_lens_output'] = helper.create_variable(dtype='float32')
        helper.append_op(type="speculate_get_seq_lens_output", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def flash_attn_bwd(q,k,v,out,softmax_lse,seed_offset,attn_mask,out_grad,dropout,causal):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("flash_attn_bwd", q,k,v,out,softmax_lse,seed_offset,attn_mask,out_grad,dropout,causal)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'q' : q,'k' : k,'v' : v,'out' : out,'softmax_lse' : softmax_lse,'seed_offset' : seed_offset,'attn_mask' : attn_mask,'out_grad' : out_grad}
        outs = {}
        outs_list = ['q_grad','k_grad','v_grad']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("flash_attn_bwd", **locals())

        outs['q_grad'] = helper.create_variable(dtype='float32')
        outs['k_grad'] = helper.create_variable(dtype='float32')
        outs['v_grad'] = helper.create_variable(dtype='float32')
        helper.append_op(type="flash_attn_bwd", inputs=ins, outputs=outs, attrs={'dropout' : dropout,'causal' : causal})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def speculate_save_output(accept_tokens,accept_num,not_need_stop,rank_id):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("speculate_save_output", accept_tokens,accept_num,not_need_stop,rank_id)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'accept_tokens' : accept_tokens,'accept_num' : accept_num,'not_need_stop' : not_need_stop}
        outs = {}
        outs_list = ['x_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("speculate_save_output", **locals())

        outs['x_out'] = accept_tokens
        helper.append_op(type="speculate_save_output", inputs=ins, outputs=outs, attrs={'rank_id' : rank_id})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def top_p_sampling_reject(probs,top_p,seed):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("top_p_sampling_reject", probs,top_p,seed)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'probs' : probs,'top_p' : top_p}
        outs = {}
        outs_list = ['samples']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("top_p_sampling_reject", **locals())

        outs['samples'] = helper.create_variable(dtype='float32')
        helper.append_op(type="top_p_sampling_reject", inputs=ins, outputs=outs, attrs={'seed' : seed})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def fused_get_rotary_embedding(input_ids,position_ids,head_dim_shape_tensor,prompt_num,theta,use_neox):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("fused_get_rotary_embedding", input_ids,position_ids,head_dim_shape_tensor,prompt_num,theta,use_neox)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'input_ids' : input_ids,'position_ids' : position_ids,'head_dim_shape_tensor' : head_dim_shape_tensor}
        outs = {}
        outs_list = ['rotary_embedding']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("fused_get_rotary_embedding", **locals())

        outs['rotary_embedding'] = helper.create_variable(dtype='float32')
        helper.append_op(type="fused_get_rotary_embedding", inputs=ins, outputs=outs, attrs={'prompt_num' : prompt_num,'theta' : theta,'use_neox' : use_neox})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def speculate_set_value_by_flags_and_idx(pre_ids_all,accept_tokens,accept_num,stop_flags,seq_lens_this_time,seq_lens_encoder,seq_lens_decoder,step_idx):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("speculate_set_value_by_flags_and_idx", pre_ids_all,accept_tokens,accept_num,stop_flags,seq_lens_this_time,seq_lens_encoder,seq_lens_decoder,step_idx)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'pre_ids_all' : pre_ids_all,'accept_tokens' : accept_tokens,'accept_num' : accept_num,'stop_flags' : stop_flags,'seq_lens_this_time' : seq_lens_this_time,'seq_lens_encoder' : seq_lens_encoder,'seq_lens_decoder' : seq_lens_decoder,'step_idx' : step_idx}
        outs = {}
        outs_list = ['pre_ids_all_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("speculate_set_value_by_flags_and_idx", **locals())

        outs['pre_ids_all_out'] = pre_ids_all
        helper.append_op(type="speculate_set_value_by_flags_and_idx", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def set_preids_token_penalty_multi_scores(pre_ids,input_ids,seq_lens_encoder,seq_lens_decoder,step_idx,stop_flags,logits,penalty_scores,frequency_scores,presence_scores,temperatures,bad_tokens,cur_len,min_len,eos_token_id):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("set_preids_token_penalty_multi_scores", pre_ids,input_ids,seq_lens_encoder,seq_lens_decoder,step_idx,stop_flags,logits,penalty_scores,frequency_scores,presence_scores,temperatures,bad_tokens,cur_len,min_len,eos_token_id)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'pre_ids' : pre_ids,'input_ids' : input_ids,'seq_lens_encoder' : seq_lens_encoder,'seq_lens_decoder' : seq_lens_decoder,'step_idx' : step_idx,'stop_flags' : stop_flags,'logits' : logits,'penalty_scores' : penalty_scores,'frequency_scores' : frequency_scores,'presence_scores' : presence_scores,'temperatures' : temperatures,'bad_tokens' : bad_tokens,'cur_len' : cur_len,'min_len' : min_len,'eos_token_id' : eos_token_id}
        outs = {}
        outs_list = ['logits_out','pre_ids_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("set_preids_token_penalty_multi_scores", **locals())

        outs['logits_out'] = logits
        outs['pre_ids_out'] = pre_ids
        helper.append_op(type="set_preids_token_penalty_multi_scores", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def get_token_penalty_multi_scores(pre_ids,logits,penalty_scores,frequency_scores,presence_scores,cur_len,min_len,eos_token_id):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("get_token_penalty_multi_scores", pre_ids,logits,penalty_scores,frequency_scores,presence_scores,cur_len,min_len,eos_token_id)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'pre_ids' : pre_ids,'logits' : logits,'penalty_scores' : penalty_scores,'frequency_scores' : frequency_scores,'presence_scores' : presence_scores,'cur_len' : cur_len,'min_len' : min_len,'eos_token_id' : eos_token_id}
        outs = {}
        outs_list = ['logits_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("get_token_penalty_multi_scores", **locals())

        outs['logits_out'] = helper.create_variable(dtype='float32')
        helper.append_op(type="get_token_penalty_multi_scores", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def rebuild_padding_v2(tmp_out,cum_offsets,seq_lens_decoder,seq_lens_encoder,output_padding_offset,max_input_length):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("rebuild_padding_v2", tmp_out,cum_offsets,seq_lens_decoder,seq_lens_encoder,output_padding_offset,max_input_length)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'tmp_out' : tmp_out,'cum_offsets' : cum_offsets,'seq_lens_decoder' : seq_lens_decoder,'seq_lens_encoder' : seq_lens_encoder,'output_padding_offset@OPTIONAL' : output_padding_offset}
        outs = {}
        outs_list = ['out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("rebuild_padding_v2", **locals())

        outs['out'] = helper.create_variable(dtype='float32')
        helper.append_op(type="rebuild_padding_v2", inputs=ins, outputs=outs, attrs={'max_input_length' : max_input_length})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def per_token_group_quant(x,group_size,transpose_scale,quant_max_bound,quant_min_bound):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("per_token_group_quant", x,group_size,transpose_scale,quant_max_bound,quant_min_bound)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'x' : x}
        outs = {}
        outs_list = ['output','scale']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("per_token_group_quant", **locals())

        outs['output'] = helper.create_variable(dtype='float32')
        outs['scale'] = helper.create_variable(dtype='float32')
        helper.append_op(type="per_token_group_quant", inputs=ins, outputs=outs, attrs={'group_size' : group_size,'transpose_scale' : transpose_scale,'quant_max_bound' : quant_max_bound,'quant_min_bound' : quant_min_bound})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def preprocess_for_moe(topk_ids,num_experts,block_size):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("preprocess_for_moe", topk_ids,num_experts,block_size)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'topk_ids' : topk_ids}
        outs = {}
        outs_list = ['sorted_ids','expert_ids','num_tokens_post_pad']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("preprocess_for_moe", **locals())

        outs['sorted_ids'] = helper.create_variable(dtype='float32')
        outs['expert_ids'] = helper.create_variable(dtype='float32')
        outs['num_tokens_post_pad'] = helper.create_variable(dtype='float32')
        helper.append_op(type="preprocess_for_moe", inputs=ins, outputs=outs, attrs={'num_experts' : num_experts,'block_size' : block_size})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def speculate_get_output(x,rank_id,wait_flag):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("speculate_get_output", x,rank_id,wait_flag)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'x' : x}
        outs = {}
        outs_list = ['x_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("speculate_get_output", **locals())

        outs['x_out'] = x
        helper.append_op(type="speculate_get_output", inputs=ins, outputs=outs, attrs={'rank_id' : rank_id,'wait_flag' : wait_flag})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def set_stop_value_multi_ends_v2(topk_ids,stop_flags,seq_lens,end_ids,next_tokens):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("set_stop_value_multi_ends_v2", topk_ids,stop_flags,seq_lens,end_ids,next_tokens)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'topk_ids' : topk_ids,'stop_flags' : stop_flags,'seq_lens' : seq_lens,'end_ids' : end_ids,'next_tokens' : next_tokens}
        outs = {}
        outs_list = ['topk_ids_out','stop_flags_out','next_tokens_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("set_stop_value_multi_ends_v2", **locals())

        outs['topk_ids_out'] = topk_ids
        outs['stop_flags_out'] = stop_flags
        outs['next_tokens_out'] = next_tokens
        helper.append_op(type="set_stop_value_multi_ends_v2", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def speculate_clear_accept_nums(accept_num,seq_lens_decoder):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("speculate_clear_accept_nums", accept_num,seq_lens_decoder)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'accept_num' : accept_num,'seq_lens_decoder' : seq_lens_decoder}
        outs = {}
        outs_list = ['seq_lens_decoder_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("speculate_clear_accept_nums", **locals())

        outs['seq_lens_decoder_out'] = seq_lens_decoder
        helper.append_op(type="speculate_clear_accept_nums", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def get_output(x,msg_queue_id,rank_id,wait_flag):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("get_output", x,msg_queue_id,rank_id,wait_flag)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'x' : x,'msg_queue_id' : msg_queue_id}
        outs = {}
        outs_list = ['x_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("get_output", **locals())

        outs['x_out'] = x
        helper.append_op(type="get_output", inputs=ins, outputs=outs, attrs={'rank_id' : rank_id,'wait_flag' : wait_flag})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def noaux_tc(scores,scores_with_bias,n_group,topk_group,topk,routed_scaling_factor):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("noaux_tc", scores,scores_with_bias,n_group,topk_group,topk,routed_scaling_factor)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'scores' : scores,'scores_with_bias' : scores_with_bias}
        outs = {}
        outs_list = ['output_tensor']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("noaux_tc", **locals())

        outs['output_tensor'] = helper.create_variable(dtype='float32')
        helper.append_op(type="noaux_tc", inputs=ins, outputs=outs, attrs={'n_group' : n_group,'topk_group' : topk_group,'topk' : topk,'routed_scaling_factor' : routed_scaling_factor})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def dequant_int8(input,out_scale,dtype):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("dequant_int8", input,out_scale,dtype)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'input' : input,'out_scale' : out_scale}
        outs = {}
        outs_list = ['output']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("dequant_int8", **locals())

        outs['output'] = helper.create_variable(dtype='float32')
        helper.append_op(type="dequant_int8", inputs=ins, outputs=outs, attrs={'dtype' : dtype})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def speculate_step_paddle(stop_flags,seq_lens_this_time,ori_seq_lens_encoder,seq_lens_encoder,seq_lens_decoder,block_tables,encoder_block_lens,is_block_step,step_block_list,step_lens,recover_block_list,recover_lens,need_block_list,need_block_len,used_list_len,free_list,free_list_len,input_ids,pre_ids,step_idx,next_tokens,first_token_ids,accept_num,block_size,encoder_decoder_block_num,max_draft_tokens):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("speculate_step_paddle", stop_flags,seq_lens_this_time,ori_seq_lens_encoder,seq_lens_encoder,seq_lens_decoder,block_tables,encoder_block_lens,is_block_step,step_block_list,step_lens,recover_block_list,recover_lens,need_block_list,need_block_len,used_list_len,free_list,free_list_len,input_ids,pre_ids,step_idx,next_tokens,first_token_ids,accept_num,block_size,encoder_decoder_block_num,max_draft_tokens)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'stop_flags' : stop_flags,'seq_lens_this_time' : seq_lens_this_time,'ori_seq_lens_encoder' : ori_seq_lens_encoder,'seq_lens_encoder' : seq_lens_encoder,'seq_lens_decoder' : seq_lens_decoder,'block_tables' : block_tables,'encoder_block_lens' : encoder_block_lens,'is_block_step' : is_block_step,'step_block_list' : step_block_list,'step_lens' : step_lens,'recover_block_list' : recover_block_list,'recover_lens' : recover_lens,'need_block_list' : need_block_list,'need_block_len' : need_block_len,'used_list_len' : used_list_len,'free_list' : free_list,'free_list_len' : free_list_len,'input_ids' : input_ids,'pre_ids' : pre_ids,'step_idx' : step_idx,'next_tokens' : next_tokens,'first_token_ids' : first_token_ids,'accept_num' : accept_num}
        outs = {}
        outs_list = ['stop_flags_out','seq_lens_this_time_out','seq_lens_encoder_out','seq_lens_decoder_out','block_tables_out','encoder_block_lens_out','is_block_step_out','step_block_list_out','step_lens_out','recover_block_list_out','recover_lens_out','need_block_list_out','need_block_len_out','used_list_len_out','free_list_out','free_list_len_out','input_ids_out','first_token_ids_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("speculate_step_paddle", **locals())

        outs['stop_flags_out'] = stop_flags
        outs['seq_lens_this_time_out'] = seq_lens_this_time
        outs['seq_lens_encoder_out'] = seq_lens_encoder
        outs['seq_lens_decoder_out'] = seq_lens_decoder
        outs['block_tables_out'] = block_tables
        outs['encoder_block_lens_out'] = encoder_block_lens
        outs['is_block_step_out'] = is_block_step
        outs['step_block_list_out'] = step_block_list
        outs['step_lens_out'] = step_lens
        outs['recover_block_list_out'] = recover_block_list
        outs['recover_lens_out'] = recover_lens
        outs['need_block_list_out'] = need_block_list
        outs['need_block_len_out'] = need_block_len
        outs['used_list_len_out'] = used_list_len
        outs['free_list_out'] = free_list
        outs['free_list_len_out'] = free_list_len
        outs['input_ids_out'] = input_ids
        outs['first_token_ids_out'] = first_token_ids
        helper.append_op(type="speculate_step_paddle", inputs=ins, outputs=outs, attrs={'block_size' : block_size,'encoder_decoder_block_num' : encoder_decoder_block_num,'max_draft_tokens' : max_draft_tokens})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def step_paddle(stop_flags,seq_lens_this_time,ori_seq_lens_encoder,seq_lens_encoder,seq_lens_decoder,block_tables,encoder_block_lens,is_block_step,step_block_list,step_lens,recover_block_list,recover_lens,need_block_list,need_block_len,used_list_len,free_list,free_list_len,input_ids,pre_ids,step_idx,next_tokens,first_token_ids,block_size,encoder_decoder_block_num):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("step_paddle", stop_flags,seq_lens_this_time,ori_seq_lens_encoder,seq_lens_encoder,seq_lens_decoder,block_tables,encoder_block_lens,is_block_step,step_block_list,step_lens,recover_block_list,recover_lens,need_block_list,need_block_len,used_list_len,free_list,free_list_len,input_ids,pre_ids,step_idx,next_tokens,first_token_ids,block_size,encoder_decoder_block_num)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'stop_flags' : stop_flags,'seq_lens_this_time' : seq_lens_this_time,'ori_seq_lens_encoder' : ori_seq_lens_encoder,'seq_lens_encoder' : seq_lens_encoder,'seq_lens_decoder' : seq_lens_decoder,'block_tables' : block_tables,'encoder_block_lens' : encoder_block_lens,'is_block_step' : is_block_step,'step_block_list' : step_block_list,'step_lens' : step_lens,'recover_block_list' : recover_block_list,'recover_lens' : recover_lens,'need_block_list' : need_block_list,'need_block_len' : need_block_len,'used_list_len' : used_list_len,'free_list' : free_list,'free_list_len' : free_list_len,'input_ids' : input_ids,'pre_ids' : pre_ids,'step_idx' : step_idx,'next_tokens' : next_tokens,'first_token_ids' : first_token_ids}
        outs = {}
        outs_list = ['stop_flags_out','seq_lens_this_time_out','seq_lens_encoder_out','seq_lens_decoder_out','block_tables_out','encoder_block_lens_out','is_block_step_out','step_block_list_out','step_lens_out','recover_block_list_out','recover_lens_out','need_block_list_out','need_block_len_out','used_list_len_out','free_list_out','free_list_len_out','input_ids_out','first_token_ids_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("step_paddle", **locals())

        outs['stop_flags_out'] = stop_flags
        outs['seq_lens_this_time_out'] = seq_lens_this_time
        outs['seq_lens_encoder_out'] = seq_lens_encoder
        outs['seq_lens_decoder_out'] = seq_lens_decoder
        outs['block_tables_out'] = block_tables
        outs['encoder_block_lens_out'] = encoder_block_lens
        outs['is_block_step_out'] = is_block_step
        outs['step_block_list_out'] = step_block_list
        outs['step_lens_out'] = step_lens
        outs['recover_block_list_out'] = recover_block_list
        outs['recover_lens_out'] = recover_lens
        outs['need_block_list_out'] = need_block_list
        outs['need_block_len_out'] = need_block_len
        outs['used_list_len_out'] = used_list_len
        outs['free_list_out'] = free_list
        outs['free_list_len_out'] = free_list_len
        outs['input_ids_out'] = input_ids
        outs['first_token_ids_out'] = first_token_ids
        helper.append_op(type="step_paddle", inputs=ins, outputs=outs, attrs={'block_size' : block_size,'encoder_decoder_block_num' : encoder_decoder_block_num})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def speculate_get_token_penalty_multi_scores(pre_ids,logits,penalty_scores,frequency_scores,presence_scores,temperatures,bad_tokens,cur_len,min_len,eos_token_id,seq_lens_this_time,output_padding_offset,output_cum_offsets,max_seq_len):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("speculate_get_token_penalty_multi_scores", pre_ids,logits,penalty_scores,frequency_scores,presence_scores,temperatures,bad_tokens,cur_len,min_len,eos_token_id,seq_lens_this_time,output_padding_offset,output_cum_offsets,max_seq_len)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'pre_ids' : pre_ids,'logits' : logits,'penalty_scores' : penalty_scores,'frequency_scores' : frequency_scores,'presence_scores' : presence_scores,'temperatures' : temperatures,'bad_tokens' : bad_tokens,'cur_len' : cur_len,'min_len' : min_len,'eos_token_id' : eos_token_id,'seq_lens_this_time' : seq_lens_this_time,'output_padding_offset' : output_padding_offset,'output_cum_offsets' : output_cum_offsets}
        outs = {}
        outs_list = ['logits_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("speculate_get_token_penalty_multi_scores", **locals())

        outs['logits_out'] = logits
        helper.append_op(type="speculate_get_token_penalty_multi_scores", inputs=ins, outputs=outs, attrs={'max_seq_len' : max_seq_len})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def draft_model_preprocess(draft_tokens,input_ids,stop_flags,seq_lens_this_time,seq_lens_encoder,seq_lens_decoder,step_idx,first_token_record,not_need_stop,accept_tokens,accept_num,base_model_seq_lens_encoder,base_model_seq_lens_decoder,base_model_step_idx,base_model_stop_flags,base_model_draft_tokens,max_draft_token,truncate_first_token):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("draft_model_preprocess", draft_tokens,input_ids,stop_flags,seq_lens_this_time,seq_lens_encoder,seq_lens_decoder,step_idx,first_token_record,not_need_stop,accept_tokens,accept_num,base_model_seq_lens_encoder,base_model_seq_lens_decoder,base_model_step_idx,base_model_stop_flags,base_model_draft_tokens,max_draft_token,truncate_first_token)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'draft_tokens' : draft_tokens,'input_ids' : input_ids,'stop_flags' : stop_flags,'seq_lens_this_time' : seq_lens_this_time,'seq_lens_encoder' : seq_lens_encoder,'seq_lens_decoder' : seq_lens_decoder,'step_idx' : step_idx,'first_token_record' : first_token_record,'not_need_stop' : not_need_stop,'accept_tokens' : accept_tokens,'accept_num' : accept_num,'base_model_seq_lens_encoder' : base_model_seq_lens_encoder,'base_model_seq_lens_decoder' : base_model_seq_lens_decoder,'base_model_step_idx' : base_model_step_idx,'base_model_stop_flags' : base_model_stop_flags,'base_model_draft_tokens' : base_model_draft_tokens}
        outs = {}
        outs_list = ['draft_tokens_out','input_ids_out','stop_flags_out','seq_lens_this_time_out','seq_lens_encoder_out','seq_lens_decoder_out','step_idx_out','not_need_stop_out','first_token_record_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("draft_model_preprocess", **locals())

        outs['draft_tokens_out'] = draft_tokens
        outs['input_ids_out'] = input_ids
        outs['stop_flags_out'] = stop_flags
        outs['seq_lens_this_time_out'] = seq_lens_this_time
        outs['seq_lens_encoder_out'] = seq_lens_encoder
        outs['seq_lens_decoder_out'] = seq_lens_decoder
        outs['step_idx_out'] = step_idx
        outs['not_need_stop_out'] = not_need_stop
        outs['first_token_record_out'] = first_token_record
        helper.append_op(type="draft_model_preprocess", inputs=ins, outputs=outs, attrs={'max_draft_token' : max_draft_token,'truncate_first_token' : truncate_first_token})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def set_stop_value_multi_ends(topk_ids,stop_flags,end_ids,mode):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("set_stop_value_multi_ends", topk_ids,stop_flags,end_ids,mode)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'topk_ids' : topk_ids,'stop_flags' : stop_flags,'end_ids' : end_ids}
        outs = {}
        outs_list = ['topk_ids_out','stop_flags_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("set_stop_value_multi_ends", **locals())

        outs['topk_ids_out'] = helper.create_variable(dtype='float32')
        outs['stop_flags_out'] = helper.create_variable(dtype='float32')
        helper.append_op(type="set_stop_value_multi_ends", inputs=ins, outputs=outs, attrs={'mode' : mode})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def update_inputs_v2(stop_flags,step_idx,not_need_stop,seq_lens_this_time,seq_lens_encoder,seq_lens_decoder,max_dec_len,input_ids,stop_nums,next_tokens,is_block_step,end_ids,kwargs_next_tokens):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("update_inputs_v2", stop_flags,step_idx,not_need_stop,seq_lens_this_time,seq_lens_encoder,seq_lens_decoder,max_dec_len,input_ids,stop_nums,next_tokens,is_block_step,end_ids,kwargs_next_tokens)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'stop_flags' : stop_flags,'step_idx' : step_idx,'not_need_stop' : not_need_stop,'seq_lens_this_time' : seq_lens_this_time,'seq_lens_encoder' : seq_lens_encoder,'seq_lens_decoder' : seq_lens_decoder,'max_dec_len' : max_dec_len,'input_ids' : input_ids,'stop_nums' : stop_nums,'next_tokens' : next_tokens,'is_block_step' : is_block_step,'end_ids' : end_ids,'kwargs_next_tokens' : kwargs_next_tokens}
        outs = {}
        outs_list = ['not_need_stop_out','seq_lens_this_time_out','seq_lens_encoder_out','seq_lens_decoder_out','input_ids_out','next_tokens_out','kwargs_next_tokens_out','step_idx_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("update_inputs_v2", **locals())

        outs['not_need_stop_out'] = not_need_stop
        outs['seq_lens_this_time_out'] = seq_lens_this_time
        outs['seq_lens_encoder_out'] = seq_lens_encoder
        outs['seq_lens_decoder_out'] = seq_lens_decoder
        outs['input_ids_out'] = input_ids
        outs['next_tokens_out'] = next_tokens
        outs['kwargs_next_tokens_out'] = kwargs_next_tokens
        outs['step_idx_out'] = step_idx
        helper.append_op(type="update_inputs_v2", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def eagle_get_base_model_hidden_states(input,seq_lens_this_time,seq_lens_encoder,seq_lens_decoder,stop_flags,accept_nums,base_model_seq_lens_this_time,base_model_seq_lens_encoder,actual_draft_token_num):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("eagle_get_base_model_hidden_states", input,seq_lens_this_time,seq_lens_encoder,seq_lens_decoder,stop_flags,accept_nums,base_model_seq_lens_this_time,base_model_seq_lens_encoder,actual_draft_token_num)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'input' : input,'seq_lens_this_time' : seq_lens_this_time,'seq_lens_encoder' : seq_lens_encoder,'seq_lens_decoder' : seq_lens_decoder,'stop_flags' : stop_flags,'accept_nums' : accept_nums,'base_model_seq_lens_this_time' : base_model_seq_lens_this_time,'base_model_seq_lens_encoder' : base_model_seq_lens_encoder}
        outs = {}
        outs_list = ['out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("eagle_get_base_model_hidden_states", **locals())

        outs['out'] = helper.create_variable(dtype='float32')
        helper.append_op(type="eagle_get_base_model_hidden_states", inputs=ins, outputs=outs, attrs={'actual_draft_token_num' : actual_draft_token_num})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def get_padding_offset(input_ids,cum_offsets,token_num,seq_len):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("get_padding_offset", input_ids,cum_offsets,token_num,seq_len)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'input_ids' : input_ids,'cum_offsets' : cum_offsets,'token_num' : token_num,'seq_len' : seq_len}
        outs = {}
        outs_list = ['x_remove_padding','cum_offsets_out','padding_offset']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("get_padding_offset", **locals())

        outs['x_remove_padding'] = helper.create_variable(dtype='float32')
        outs['cum_offsets_out'] = helper.create_variable(dtype='float32')
        outs['padding_offset'] = helper.create_variable(dtype='float32')
        helper.append_op(type="get_padding_offset", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def draft_model_set_value_by_flags(draft_tokens,pre_ids_all,stop_flags,seq_lens_this_time,seq_lens_encoder,seq_lens_decoder,step_idx):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("draft_model_set_value_by_flags", draft_tokens,pre_ids_all,stop_flags,seq_lens_this_time,seq_lens_encoder,seq_lens_decoder,step_idx)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'draft_tokens' : draft_tokens,'pre_ids_all' : pre_ids_all,'stop_flags' : stop_flags,'seq_lens_this_time' : seq_lens_this_time,'seq_lens_encoder' : seq_lens_encoder,'seq_lens_decoder' : seq_lens_decoder,'step_idx' : step_idx}
        outs = {}
        outs_list = ['pre_ids_all_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("draft_model_set_value_by_flags", **locals())

        outs['pre_ids_all_out'] = pre_ids_all
        helper.append_op(type="draft_model_set_value_by_flags", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def ngram_match(input_ids,input_ids_len,pre_ids,step_idx,draft_token_num,draft_tokens,seq_lens_this_time,seq_lens_encoder,seq_lens_decoder,max_dec_len,real_batch_size,max_ngram_size,max_draft_tokens):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("ngram_match", input_ids,input_ids_len,pre_ids,step_idx,draft_token_num,draft_tokens,seq_lens_this_time,seq_lens_encoder,seq_lens_decoder,max_dec_len,real_batch_size,max_ngram_size,max_draft_tokens)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'input_ids' : input_ids,'input_ids_len' : input_ids_len,'pre_ids' : pre_ids,'step_idx' : step_idx,'draft_token_num' : draft_token_num,'draft_tokens' : draft_tokens,'seq_lens_this_time' : seq_lens_this_time,'seq_lens_encoder' : seq_lens_encoder,'seq_lens_decoder' : seq_lens_decoder,'max_dec_len' : max_dec_len}
        outs = {}
        outs_list = ['draft_tokens_out','seq_lens_this_time_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("ngram_match", **locals())

        outs['draft_tokens_out'] = draft_tokens
        outs['seq_lens_this_time_out'] = seq_lens_this_time
        helper.append_op(type="ngram_match", inputs=ins, outputs=outs, attrs={'real_batch_size' : real_batch_size,'max_ngram_size' : max_ngram_size,'max_draft_tokens' : max_draft_tokens})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def speculate_update(seq_lens_encoder,seq_lens_decoder,not_need_stop,draft_tokens,actual_draft_token_nums,accept_tokens,accept_num,stop_flags,seq_lens_this_time,is_block_step):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("speculate_update", seq_lens_encoder,seq_lens_decoder,not_need_stop,draft_tokens,actual_draft_token_nums,accept_tokens,accept_num,stop_flags,seq_lens_this_time,is_block_step)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'seq_lens_encoder' : seq_lens_encoder,'seq_lens_decoder' : seq_lens_decoder,'not_need_stop' : not_need_stop,'draft_tokens' : draft_tokens,'actual_draft_token_nums' : actual_draft_token_nums,'accept_tokens' : accept_tokens,'accept_num' : accept_num,'stop_flags' : stop_flags,'seq_lens_this_time' : seq_lens_this_time,'is_block_step' : is_block_step}
        outs = {}
        outs_list = ['seq_lens_encoder_out','seq_lens_decoder_out','not_need_stop_out','draft_tokens_out','actual_draft_token_nums_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("speculate_update", **locals())

        outs['seq_lens_encoder_out'] = seq_lens_encoder
        outs['seq_lens_decoder_out'] = seq_lens_decoder
        outs['not_need_stop_out'] = not_need_stop
        outs['draft_tokens_out'] = draft_tokens
        outs['actual_draft_token_nums_out'] = actual_draft_token_nums
        helper.append_op(type="speculate_update", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def draft_model_postprocess(base_model_draft_tokens,base_model_seq_lens_this_time,base_model_seq_lens_encoder,base_model_stop_flags):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("draft_model_postprocess", base_model_draft_tokens,base_model_seq_lens_this_time,base_model_seq_lens_encoder,base_model_stop_flags)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'base_model_draft_tokens' : base_model_draft_tokens,'base_model_seq_lens_this_time' : base_model_seq_lens_this_time,'base_model_seq_lens_encoder' : base_model_seq_lens_encoder,'base_model_stop_flags' : base_model_stop_flags}
        outs = {}
        outs_list = ['base_model_draft_tokens_out','base_model_seq_lens_this_time_out','base_model_stop_flags_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("draft_model_postprocess", **locals())

        outs['base_model_draft_tokens_out'] = base_model_draft_tokens
        outs['base_model_seq_lens_this_time_out'] = base_model_seq_lens_this_time
        outs['base_model_stop_flags_out'] = base_model_stop_flags
        helper.append_op(type="draft_model_postprocess", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def save_with_output(x,batch_idx,step_idx,file_path,rank_id):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("save_with_output", x,batch_idx,step_idx,file_path,rank_id)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'x' : x,'batch_idx' : batch_idx,'step_idx' : step_idx}
        outs = {}
        outs_list = ['out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("save_with_output", **locals())

        outs['out'] = helper.create_variable(dtype='float32')
        helper.append_op(type="save_with_output", inputs=ins, outputs=outs, attrs={'file_path' : file_path,'rank_id' : rank_id})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def top_p_candidates(probs,top_p,output_padding_offset,candidates_len,max_seq_len):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("top_p_candidates", probs,top_p,output_padding_offset,candidates_len,max_seq_len)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'probs' : probs,'top_p' : top_p,'output_padding_offset' : output_padding_offset}
        outs = {}
        outs_list = ['verify_scores','verify_tokens','actual_candidate_lens']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("top_p_candidates", **locals())

        outs['verify_scores'] = helper.create_variable(dtype='float32')
        outs['verify_tokens'] = helper.create_variable(dtype='float32')
        outs['actual_candidate_lens'] = helper.create_variable(dtype='float32')
        helper.append_op(type="top_p_candidates", inputs=ins, outputs=outs, attrs={'candidates_len' : candidates_len,'max_seq_len' : max_seq_len})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def tune_cublaslt_gemm(k,n,m_start,m_end,dtype,is_test,is_read_from_file,path):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("tune_cublaslt_gemm", k,n,m_start,m_end,dtype,is_test,is_read_from_file,path)
        res = []
        start_idx = 0
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'K' : k,'N' : n}
        outs = {}
        outs_list = []
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("tune_cublaslt_gemm", **locals())

        helper.append_op(type="tune_cublaslt_gemm", inputs=ins, outputs=outs, attrs={'M_start' : m_start,'M_end' : m_end,'dtype' : dtype,'is_test' : is_test,'is_read_from_file' : is_read_from_file,'path' : path})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def quant_int8(input,shift,smooth,scale,round_type,max_bound,min_bound):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("quant_int8", input,shift,smooth,scale,round_type,max_bound,min_bound)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'input' : input,'shift@OPTIONAL' : shift,'smooth@OPTIONAL' : smooth}
        outs = {}
        outs_list = ['output']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("quant_int8", **locals())

        outs['output'] = helper.create_variable(dtype='float32')
        helper.append_op(type="quant_int8", inputs=ins, outputs=outs, attrs={'scale' : scale,'round_type' : round_type,'max_bound' : max_bound,'min_bound' : min_bound})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def save_output_dygraph(all_token_ids,tokens,result_ids,step_idx):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("save_output_dygraph", all_token_ids,tokens,result_ids,step_idx)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'all_token_ids' : all_token_ids,'tokens' : tokens,'result_ids' : result_ids,'step_idx' : step_idx}
        outs = {}
        outs_list = ['all_token_ids_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("save_output_dygraph", **locals())

        outs['all_token_ids_out'] = all_token_ids
        helper.append_op(type="save_output_dygraph", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def write_int8_cache_kv(input_k,input_v,cache_kv,k_quant_scales,v_quant_scales,q_dequant_scales,v_dequant_scales):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("write_int8_cache_kv", input_k,input_v,cache_kv,k_quant_scales,v_quant_scales,q_dequant_scales,v_dequant_scales)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'input_k' : input_k,'input_v' : input_v,'cache_kv' : cache_kv,'k_quant_scales' : k_quant_scales,'v_quant_scales' : v_quant_scales,'q_dequant_scales' : q_dequant_scales,'v_dequant_scales' : v_dequant_scales}
        outs = {}
        outs_list = ['cache_kv_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("write_int8_cache_kv", **locals())

        outs['cache_kv_out'] = cache_kv
        helper.append_op(type="write_int8_cache_kv", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def per_tensor_quant_fp8(x,scale):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("per_tensor_quant_fp8", x,scale)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'x' : x,'scale@OPTIONAL' : scale}
        outs = {}
        outs_list = ['output','scale_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("per_tensor_quant_fp8", **locals())

        outs['output'] = helper.create_variable(dtype='float32')
        outs['scale_out'] = helper.create_variable(dtype='float32')
        helper.append_op(type="per_tensor_quant_fp8", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def speculate_verify(accept_tokens,accept_num,step_idx,seq_lens_encoder,seq_lens_decoder,stop_flags,draft_tokens,seq_lens_this_time,verify_tokens,verify_scores,max_dec_len,end_tokens,is_block_step,output_cum_offsets,actual_candidate_len,actual_draft_token_nums,topp,max_seq_len,verify_window,enable_topp):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("speculate_verify", accept_tokens,accept_num,step_idx,seq_lens_encoder,seq_lens_decoder,stop_flags,draft_tokens,seq_lens_this_time,verify_tokens,verify_scores,max_dec_len,end_tokens,is_block_step,output_cum_offsets,actual_candidate_len,actual_draft_token_nums,topp,max_seq_len,verify_window,enable_topp)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'accept_tokens' : accept_tokens,'accept_num' : accept_num,'step_idx' : step_idx,'seq_lens_encoder' : seq_lens_encoder,'seq_lens_decoder' : seq_lens_decoder,'stop_flags' : stop_flags,'draft_tokens' : draft_tokens,'seq_lens_this_time' : seq_lens_this_time,'verify_tokens' : verify_tokens,'verify_scores' : verify_scores,'max_dec_len' : max_dec_len,'end_tokens' : end_tokens,'is_block_step' : is_block_step,'output_cum_offsets' : output_cum_offsets,'actual_candidate_len' : actual_candidate_len,'actual_draft_token_nums' : actual_draft_token_nums,'topp' : topp}
        outs = {}
        outs_list = ['accept_tokens_out','accept_num_out','step_idx_out','stop_flags_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("speculate_verify", **locals())

        outs['accept_tokens_out'] = accept_tokens
        outs['accept_num_out'] = accept_num
        outs['step_idx_out'] = step_idx
        outs['stop_flags_out'] = stop_flags
        helper.append_op(type="speculate_verify", inputs=ins, outputs=outs, attrs={'max_seq_len' : max_seq_len,'verify_window' : verify_window,'enable_topp' : enable_topp})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def eagle_get_self_hidden_states(input,last_seq_lens_this_time,seq_lens_this_time,step_idx):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("eagle_get_self_hidden_states", input,last_seq_lens_this_time,seq_lens_this_time,step_idx)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'input' : input,'last_seq_lens_this_time' : last_seq_lens_this_time,'seq_lens_this_time' : seq_lens_this_time,'step_idx' : step_idx}
        outs = {}
        outs_list = ['out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("eagle_get_self_hidden_states", **locals())

        outs['out'] = helper.create_variable(dtype='float32')
        helper.append_op(type="eagle_get_self_hidden_states", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def write_cache_kv(input_k,input_v,cache_kv,sequence_lengths):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("write_cache_kv", input_k,input_v,cache_kv,sequence_lengths)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'input_k' : input_k,'input_v' : input_v,'cache_kv' : cache_kv,'sequence_lengths' : sequence_lengths}
        outs = {}
        outs_list = ['cache_kv_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("write_cache_kv", **locals())

        outs['cache_kv_out'] = cache_kv
        helper.append_op(type="write_cache_kv", inputs=ins, outputs=outs, attrs={})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


from paddle import _C_ops
from paddle.framework import in_dynamic_or_pir_mode
from paddle.base.layer_helper import LayerHelper

def encode_rotary_qk(q,kv,rotary_emb,seq_lens,rotary_emb_dims,use_neox):
    # The output variable's dtype use default value 'float32',
    # and the actual dtype of output variable will be inferred in runtime.
    if in_dynamic_or_pir_mode():
        outs = _C_ops._run_custom_op("encode_rotary_qk", q,kv,rotary_emb,seq_lens,rotary_emb_dims,use_neox)
        res = []
        start_idx = 0
        res.append(outs[start_idx])
        start_idx += 1
        res.append(outs[start_idx])
        start_idx += 1
        return res[0] if len(res)==1 else res
    else:
        ins = {}
        ins_map = {'q' : q,'kv' : kv,'rotary_emb' : rotary_emb,'seq_lens' : seq_lens}
        outs = {}
        outs_list = ['rotary_q_out','rotary_kv_out']
        for key, value in ins_map.items():
            # handle optional inputs
            if value is not None:
                ins[key] = value
        helper = LayerHelper("encode_rotary_qk", **locals())

        outs['rotary_q_out'] = q
        outs['rotary_kv_out'] = kv
        helper.append_op(type="encode_rotary_qk", inputs=ins, outputs=outs, attrs={'rotary_emb_dims' : rotary_emb_dims,'use_neox' : use_neox})
        res = [outs[out_name] if out_name in outs.keys() else None for out_name in outs_list]
        return res[0] if len(res)==1 else res


import os
import sys
import types
import paddle
import importlib.abc
import importlib.util

cur_dir = os.path.dirname(os.path.abspath(__file__))
so_path = os.path.join(cur_dir, "paddlenlp_ops_70_pd_.so")

def __bootstrap__():
    assert os.path.exists(so_path)
    # load custom op shared library with abs path
    custom_ops = paddle.utils.cpp_extension.load_op_meta_info_and_register_op(so_path)

    if os.name == 'nt' or sys.platform.startswith('darwin'):
        # Cpp Extension only support Linux now
        mod = types.ModuleType(__name__)
    else:
        try:
            spec = importlib.util.spec_from_file_location(__name__, so_path)
            assert spec is not None
            mod = importlib.util.module_from_spec(spec)
            assert isinstance(spec.loader, importlib.abc.Loader)
            spec.loader.exec_module(mod)
        except ImportError:
            mod = types.ModuleType(__name__)

    for custom_op in custom_ops:
        setattr(mod, custom_op, eval(custom_op))

__bootstrap__()

